Bug 6788 - expm1() does not set errno on overflow
Summary: expm1() does not set errno on overflow
Status: RESOLVED FIXED
Alias: None
Product: glibc
Classification: Unclassified
Component: math (show other bugs)
Version: unspecified
: P2 normal
Target Milestone: ---
Assignee: Andreas Jaeger
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-07-30 15:07 UTC by Michael Kerrisk
Modified: 2014-07-04 05:46 UTC (History)
1 user (show)

See Also:
Host:
Target:
Build:
Last reconfirmed:
fweimer: security-


Attachments
test program (2.72 KB, text/plain)
2008-07-31 08:57 UTC, Michael Kerrisk
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Kerrisk 2008-07-30 15:07:54 UTC
On overflow, expm1() raises an overflow exception (e.g., expm1(1e4) on x86-32),
but does not set errno.  For this case, errno should be set to ERANGE.

Background: 
On error, many glibc math functions both set errno and raise an exception
(fetestexcept(3)).  For example, the following  function all do this: acos(),
asin(), cosh(), sinh(), acosh(), asinh(), exp(), exp2(), ldexp(), log(),
log10(), log2().  However, there is much inconsistency.  Some functions raise an
exception, but don't set errno.  Some functions set errno for some errors, but
not others.  A few set errno, but don't raise an exception.  This series of bug
reports documents deviations from what I consider the ideal: all functions
should BOTH set errno AND raise an exception for all errors.

All of these reports relate to tests on glibc 2.8 (as provided by SUSE 11.0).
Comment 1 Michael Kerrisk 2008-07-31 08:57:07 UTC
Created attachment 2853 [details]
test program

Sample run demonstrating problem (note that raising FE_INVALID here is probably
also a bug):

$ /tmp/mt_expm1 1e5
errno == 0
fetestexcept() says:  FE_INVALID FE_OVERFLOW FE_INEXACT
expm1(1.00000000000000000e+05)=nan
0 FE_OVERFLOW nan
Comment 2 Michael Kerrisk 2010-09-11 15:24:04 UTC
This bug was fixed in glibc 2.10. The man page is updated for man-pages-2.37.
Comment 3 Michael Kerrisk 2010-09-12 06:38:46 UTC
Correcting my earl(In reply to comment #2)
> This bug was fixed in glibc 2.10. The man page is updated for man-pages-2.37.

Correction. It looks like the fix was in 2.11, or possibly 2.12. I have no test
system for 2.11, but 2.12 passes. From the source (sysdeps/i386/fpu/s_expm1.S)
it looks like the changes were in 2.11.